/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   IBM XL C/C++ for Linux, V11.1 (5724-X14)                         */
/*                                                                    */
/*   Copyright IBM Corp. 1998, 2010.                                  */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/
/*
 * The following [enclosed] code is sample code created by IBM
 * Corporation.  This sample code is not part of any standard IBM product
 * and is provided to you solely for the purpose of assisting you in the
 * development of your applications.  The code is provided 'AS IS',
 * without warranty of any kind.  IBM shall not be liable for any damages
 * arising out of your use of the sample code, even if they have been
 * advised of the possibility of such damages.
 */

/*
 * Simple tracing functions for use with -qfunctrace
 *
 * To use these functions:
 *   xlC -c tracing_routines.cpp
 *   xlC yourfile.cpp -qfunctrace tracing_routines.o
 */

#include <stdio.h>

extern "C" void
__func_trace_enter(const char * const proc_name,
                   const char * const file_name,
                   const int line_no,
                   void ** const id)
{
  printf("{ %s (%s:%d)\n", proc_name, file_name, line_no);
}

extern "C" void
__func_trace_exit(const char * const proc_name,
                  const char * const file_name,
                  const int line_no,
                  void ** const id)
{
  printf("} %s (%s:%d)\n", proc_name, file_name, line_no);
}

extern "C" void
__func_trace_catch(const char * const proc_name,
                   const char * const file_name,
                   int line_no,
                   void ** const id)
{
  printf("  %s (%s:%d) catch block\n", proc_name, file_name, line_no);
}
