/*-----------------------------------------------------------------*/
/* C declarations for the Power7 SIMD MASS functions               */
/*-----------------------------------------------------------------*/

/********************************************************************/
/*                                                                  */
/* Licensed Materials - Property of IBM                             */
/* IBM MASS Library Component V6.0.                                 */
/* Copyright IBM Corp. 2008,2009. All Rights Reserved.              */
/* US Government Users Restricted Rights - Use, duplication or      */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.*/
/*                                                                  */
/********************************************************************/

/*  SCCS ID STRING    97  1.1 12/16/09 16:47:42        9/29/11 20:04:53 */

#ifdef __cplusplus
  extern "C" {
#endif

vector double acosd2(vector double);
vector double asind2(vector double);
vector double atan2d2(vector double,vector double);
vector double cbrtd2(vector double);
vector double cosd2(vector double);
vector double coshd2(vector double);
vector double divd2(vector double,vector double);
vector double expd2(vector double);
vector double expm1d2(vector double);
vector double exp2d2(vector double);
vector double exp2m1d2(vector double);
vector double erfd2(vector double);
vector double erfcd2(vector double);
vector double hypotd2(vector double,vector double);
vector double lgammad2(vector double);
vector double logd2(vector double);
vector double log2d2(vector double);
vector double log21pd2(vector double);
vector double log10d2(vector double);
vector double log1pd2(vector double);
vector double powd2(vector double,vector double);
vector double qdrtd2(vector double);
vector double rcbrtd2(vector double);
vector double recipd2(vector double);
vector double rqdrtd2(vector double);
vector double rsqrtd2(vector double);
vector double sind2(vector double);
void sincosd2(vector double,vector double*,vector double*);
vector double sinhd2(vector double);
vector double sqrtd2(vector double);
vector double tand2(vector double);
vector double tanhd2(vector double);
vector double acoshd2(vector double);
vector double asinhd2(vector double);
vector double atanhd2(vector double);

vector float acosf4(vector float);
vector float asinf4(vector float);
vector float atan2f4(vector float,vector float);
vector float cbrtf4(vector float);
vector float cosf4(vector float);
vector float coshf4(vector float);
vector float divf4(vector float,vector float);
vector float expf4(vector float);
vector float expm1f4(vector float);
vector float exp2f4(vector float);
vector float exp2m1f4(vector float);
vector float erff4(vector float);
vector float erfcf4(vector float);
vector float hypotf4(vector float,vector float);
vector float lgammaf4(vector float);
vector float logf4(vector float);
vector float log2f4(vector float);
vector float log21pf4(vector float);
vector float log10f4(vector float);
vector float log1pf4(vector float);
vector float powf4(vector float,vector float);
vector float qdrtf4(vector float);
vector float rcbrtf4(vector float);
vector float recipf4(vector float);
vector float rqdrtf4(vector float);
vector float rsqrtf4(vector float);
vector float sinf4(vector float);
void sincosf4(vector float,vector float*,vector float*);
vector float sinhf4(vector float);
vector float sqrtf4(vector float);
vector float tanf4(vector float);
vector float tanhf4(vector float);
vector float acoshf4(vector float);
vector float asinhf4(vector float);
vector float atanhf4(vector float);


#ifdef __cplusplus
}
#endif

